"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var base_module_1 = require("./base.module");
var add_class_directive_1 = require("./directives/add-class.directive");
var alert_directive_1 = require("./directives/alert.directive");
var background_image_directive_1 = require("./directives/background-image.directive");
var comment_area_directive_1 = require("./directives/comment-area.directive");
var convert_to_number_directive_1 = require("./directives/convert-to-number.directive");
var date_time_picker_directive_1 = require("./directives/date-time-picker.directive");
var file_button_directive_1 = require("./directives/file-button.directive");
var file_drag_and_drop_directive_1 = require("./directives/file-drag-and-drop.directive");
var focus_when_directive_1 = require("./directives/focus-when.directive");
var format_as_number_directive_1 = require("./directives/format-as-number.directive");
var full_select_directive_1 = require("./directives/full-select.directive");
var horizontal_scroller_directive_1 = require("./directives/horizontal-scroller.directive");
var keyboard_listener_directive_1 = require("./directives/keyboard-listener.directive");
var md_ui_sref_active_directive_1 = require("./directives/md-ui-sref-active.directive");
var on_keyboard_directive_1 = require("./directives/on-keyboard.directive");
var prevent_event_if_directive_1 = require("./directives/prevent-event-if.directive");
var remove_class_directive_1 = require("./directives/remove-class.directive");
var scroll_to_bottom_directive_1 = require("./directives/scroll-to-bottom.directive");
var scroll_toggle_class_directive_1 = require("./directives/scroll-toggle-class.directive");
var scroll_to_top_directive_1 = require("./directives/scroll-to-top.directive");
var select_toggle_class_directive_1 = require("./directives/select-toggle-class.directive");
var toggle_class_directive_1 = require("./directives/toggle-class.directive");
var toggle_class_on_click_directive_1 = require("./directives/toggle-class-on-click.directive");
var tooltip_directive_1 = require("./directives/tooltip.directive");
var alert_service_1 = require("./services/alert.service");
var async_resource_service_1 = require("./services/async-resource.service");
var date_service_1 = require("./services/date.service");
var exception_service_1 = require("./services/exception.service");
var file_management_service_1 = require("./services/file-management.service");
var geolocation_service_1 = require("./services/geolocation.service");
var key_processor_service_1 = require("./services/key-processor.service");
var message_bus_service_1 = require("./services/message-bus.service");
var modal_service_1 = require("./services/modal.service");
var logging_service_1 = require("./services/logging.service");
var url_service_1 = require("./services/url.service");
var injector_service_1 = require("./services/injector.service");
var FrameworkModule = /** @class */ (function (_super) {
    tslib_1.__extends(FrameworkModule, _super);
    function FrameworkModule() {
        var _this = this;
        if (FrameworkModule.internalInstance != null)
            throw new Error("The program does not allow more than one instance of the ModuleBase.");
        _this = _super.call(this) || this;
        FrameworkModule.internalInstance = _this;
        _this.logger.writeMessage("creating application");
        return _this;
    }
    Object.defineProperty(FrameworkModule, "instance", {
        get: function () { return FrameworkModule.internalInstance; },
        enumerable: true,
        configurable: true
    });
    FrameworkModule.prototype.getModuleName = function () {
        return "miracledevs-framework";
    };
    FrameworkModule.prototype.register = function () {
        _super.prototype.register.call(this);
        this.registerServices([
            injector_service_1.InjectorService,
            alert_service_1.AlertService,
            async_resource_service_1.AsyncResourceService,
            date_service_1.DateService,
            exception_service_1.ExceptionService,
            file_management_service_1.FileManagementService,
            geolocation_service_1.GeolocationService,
            key_processor_service_1.KeyProcessorService,
            logging_service_1.LoggingService,
            message_bus_service_1.MessageBus,
            modal_service_1.ModalService,
            url_service_1.UrlService
        ]);
        this.registerDirectives([
            add_class_directive_1.AddClassDirective,
            alert_directive_1.AlertDirective,
            background_image_directive_1.BackgroundImageDirective,
            comment_area_directive_1.CommentAreaDirective,
            convert_to_number_directive_1.ConvertToNumberDirective,
            date_time_picker_directive_1.DateTimePickerDirective,
            file_button_directive_1.FileButtonDirective,
            file_drag_and_drop_directive_1.FileDragAndDropDirective,
            focus_when_directive_1.FocusWhenDirective,
            format_as_number_directive_1.FormatAsNumberDirective,
            full_select_directive_1.FullSelectDirective,
            horizontal_scroller_directive_1.HorizontalScrollerDirective,
            keyboard_listener_directive_1.KeyboardListenerDirective,
            md_ui_sref_active_directive_1.MdUiSrefActiveDirective,
            on_keyboard_directive_1.OnKeyboardDirective,
            prevent_event_if_directive_1.PreventEventIfDirective,
            remove_class_directive_1.RemoveClassDirective,
            scroll_to_bottom_directive_1.ScrollToBottomDirective,
            scroll_toggle_class_directive_1.ScrollToggleClassDirective,
            scroll_to_top_directive_1.ScrollToTopDirective,
            select_toggle_class_directive_1.SelectToggleClassDirective,
            toggle_class_directive_1.ToggleClassDirective,
            toggle_class_on_click_directive_1.ToggleClassOnClickDirective,
            tooltip_directive_1.TooltipDirective
        ]);
    };
    FrameworkModule.prototype.configureRoutes = function (stateProvider, urlRouterProvider, httpProvider, location) {
    };
    FrameworkModule.prototype.authorizeRoute = function (rootScope, state, injector) {
    };
    FrameworkModule.prototype.getModuleDependencies = function () {
        return ["ui.router", "ngAnimate", "pascalprecht.translate"];
    };
    FrameworkModule.internalInstance = new FrameworkModule();
    return FrameworkModule;
}(base_module_1.ModuleBase));
exports.FrameworkModule = FrameworkModule;
