/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
import { ServiceBase } from "./base.service";
import { ArrayList } from "@miracledevs/paradigm-ui-web-shared";
import { LoggingService } from "./logging.service";
export declare class AlertService extends ServiceBase {
    private logger;
    private alerts;
    constructor(logger: LoggingService);
    add(alertType: AlertType, message: string): void;
    addError(message: string): void;
    addWarning(message: string): void;
    addMessage(message: string): void;
    remove(index: number | Alert): void;
    get(index: number): Alert;
    getAlerts(): ArrayList<Alert>;
    static factory(logger: LoggingService): AlertService;
}
export declare enum AlertType {
    Message = 0,
    Warning = 1,
    Error = 2,
}
export declare class Alert {
    private alertType;
    private innerMessage;
    readonly type: AlertType;
    readonly typeName: string;
    readonly message: string;
    constructor(alertType: AlertType, message: string);
    private static getTypeName(alertType);
}
