"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
var base_service_1 = require("./base.service");
var service_1 = require("../decorators/service");
var angular_service_1 = require("./angular.service");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var angular = require("angular");
var AsyncResourceService = /** @class */ (function (_super) {
    tslib_1.__extends(AsyncResourceService, _super);
    function AsyncResourceService(sce, q, document) {
        var _this = _super.call(this) || this;
        _this.sce = sce;
        _this.q = q;
        _this.document = document;
        _this.deferredRequests = new paradigm_ui_web_shared_1.Dictionary();
        return _this;
    }
    AsyncResourceService_1 = AsyncResourceService;
    AsyncResourceService.prototype.loadScript = function (url) {
        return this.loadResource("script", url);
    };
    AsyncResourceService.prototype.loadImage = function (url) {
        return this.loadResource("img", url);
    };
    AsyncResourceService.prototype.loadVieo = function (url) {
        return this.loadResource("video", url);
    };
    AsyncResourceService.prototype.loadResource = function (type, url) {
        if (this.deferredRequests.containsKey(url))
            return this.deferredRequests.get(url).promise;
        var defer = this.q.defer();
        this.deferredRequests.add(url, defer);
        this.sce.trustAsResourceUrl(url);
        var element = angular.element("<" + type + "></" + type + ">");
        this.document.find("body").append(element);
        element.on("load", function () { return defer.resolve(); });
        element.attr("id", "async script");
        element[0]["src"] = url;
        return defer.promise;
    };
    AsyncResourceService.factory = function (sce, q, document) {
        return new AsyncResourceService_1(sce, q, document);
    };
    AsyncResourceService = AsyncResourceService_1 = tslib_1.__decorate([
        service_1.Service({
            name: "$pd-asyncResourceService",
            dependencies: [angular_service_1.AngularServices.sce, angular_service_1.AngularServices.q, angular_service_1.AngularServices.document]
        })
    ], AsyncResourceService);
    return AsyncResourceService;
    var AsyncResourceService_1;
}(base_service_1.ServiceBase));
exports.AsyncResourceService = AsyncResourceService;
